typedef unsigned long			uint32;

struct AreaAttr
{
	unsigned int uHWMark;
};

#ifdef __cplusplus
extern "C" {
#endif

//messages attribs
#define MSG_ATTR_AREA	 					0
#define MSG_ATTR_STATUS 				1
#define MSG_ATTR_FROM						2
#define MSG_ATTR_TO							3
#define MSG_ATTR_OADDR					4
#define MSG_ATTR_DADDR					5
#define MSG_ATTR_SUBJECT			  6
#define MSG_ATTR_DATE_WRITTEN		7
#define MSG_ATTR_DATE_RECEIVED	8
#define MSG_ATTR_ATTRIBUTES			9
#define KLUDGES_ATTR						10 // do not use in raw attribs writing!!!
#define KLUDGES_ATTR_MSGID			11
#define KLUDGES_ATTR_REPLY			12
#define KLUDGES_ATTR_FLAGS			13
#define KLUDGES_ATTR_PATH				14
#define KLUDGES_ATTR_SEENBY			15
#define KLUDGES_ATTR_FTS				16
#define LINKS_ATTR							17 // do not use in raw attribs writing!!!
#define LINKS_ATTR_MSGIDCRC			18
#define LINKS_ATTR_REPLYCRC			19
#define LINKS_ATTR_REPLYTO			20
#define LINKS_ATTR_REPLY1ST			21
#define LINKS_ATTR_REPLYNEXT		22
#define AREA_ATTR_HIGHWATER			23

#define KLUDGES_ATTR_FIRST			KLUDGES_ATTR_MSGID
#define KLUDGES_ATTR_LAST				KLUDGES_ATTR_FTS

#define ATTR_COUNT AREA_ATTR_HIGHWATER+1

struct bfs_attribs{ 
	char *name;
	uint32 type;
};

extern struct bfs_attribs bfs_attribs[ATTR_COUNT];

int _bfs_ReadAttr(const char *path, int nAttr, void *pbuf, int buflen);
int _bfs_WriteAttr(const char *path, int nAttr, void *pdata, int datalen);

long _bfs_CreateKludges();

int _bfs_ReadKludge(long kHandle, int nKludge, int nIdx, const void **ppbuf, int *pbuflen);
int _bfs_AddKludge(long kHandle, int nKludge, const void *pdata, int datalen);
int _bfs_CountKludges(long kHandle, int nKludge);

void _bfs_ReleaseKludges(long kHandle);

int _bfs_ReadAttrKludges(const char *path, int nAttr, long *pkHandle);
int _bfs_WriteAttrKludges(const char *path, int nAttr, long kHandle);

/*------- Conversion Flavors ---------------------------------*/ 
enum { 
        ISO1_CONVERSION,                              /* ISO 8859-1 */ 
        ISO2_CONVERSION,                              /* ISO 8859-2 */ 
        ISO3_CONVERSION,                              /* ISO 8859-3 */ 
        ISO4_CONVERSION,                              /* ISO 8859-4 */ 
        ISO5_CONVERSION,                              /* ISO 8859-5 */ 
        ISO6_CONVERSION,                              /* ISO 8859-6 */ 
        ISO7_CONVERSION,                              /* ISO 8859-7 */ 
        ISO8_CONVERSION,                              /* ISO 8859-8 */ 
        ISO9_CONVERSION,                              /* ISO 8859-9 */ 
        ISO10_CONVERSION,                             /* ISO 8859-10 */ 
        MAC_ROMAN_CONVERSION,                 /* Macintosh Roman */ 
        SJIS_CONVERSION,                              /* Shift-JIS */ 
        EUC_CONVERSION,                               /* EUC Packed Japanese */ 
        JIS_CONVERSION,                               /* JIS X 0208-1990 */ 
        MS_WINDOWS_CONVERSION,                /* MS-Windows Codepage 1252 */ 
        UNICODE_CONVERSION,                   /* Unicode 2.0 */ 
        KOI8R_CONVERSION,                             /* KOI8-R */ 
        MS_WINDOWS_1251_CONVERSION,   /* MS-Windows Codepage 1251 */ 
        MS_DOS_866_CONVERSION,                /* MS-DOS Codepage 866 */ 
        MS_DOS_CONVERSION,                    /* MS-DOS Codepage 437 */ 
        EUC_KR_CONVERSION,                    /* EUC Korean */ 
        ISO13_CONVERSION,                             /* ISO 8859-13 */ 
        ISO14_CONVERSION,                             /* ISO 8859-14 */ 
        ISO15_CONVERSION                              /* ISO 8859-15 */ 
};

/*
**  Message status bits
*/
#define MSG_LOCAL       0x00000001L /* Msg created locally */
#define MSG_INTRANSIT   0x00000002L /* Msg is in-transit */
#define MSG_PRIVATE     0x00000004L /* Private */
#define MSG_READ        0x00000008L /* Read by addressee */
#define MSG_SENT        0x00000010L /* Sent to remote */
#define MSG_KILLSENT    0x00000020L /* Kill when sent */
#define MSG_ARCHIVESENT 0x00000040L /* Archive when sent */
#define MSG_HOLD        0x00000080L /* Hold for pick-up */
#define MSG_CRASH       0x00000100L /* Crash */
#define MSG_IMMEDIATE   0x00000200L /* Send Msg now, ignore restrictions */
#define MSG_DIRECT      0x00000400L /* Send directly to destination */
#define MSG_GATE        0x00000800L /* Send via gateway */
#define MSG_FILEREQUEST 0x00001000L /* File request */
#define MSG_FILEATTACH  0x00002000L /* File(s) attached to Msg */
#define MSG_TRUNCFILE   0x00004000L /* Truncate file(s) when sent */
#define MSG_KILLFILE    0x00008000L /* Delete file(s) when sent */
#define MSG_RECEIPTREQ  0x00010000L /* Return receipt requested */
#define MSG_CONFIRMREQ  0x00020000L /* Confirmation receipt requested */
#define MSG_ORPHAN      0x00040000L /* Unknown destination */
#define MSG_ENCRYPT     0x00080000L /* Msg text is encrypted */
#define MSG_COMPRESS    0x00100000L /* Msg text is compressed */
#define MSG_ESCAPED     0x00200000L /* Msg text is seven bit ASCII */
#define MSG_FPU         0x00400000L /* Force pickup */
#define MSG_TYPELOCAL   0x00800000L /* Msg is for local use only (no export) */
#define MSG_TYPEECHO    0x01000000L /* Msg is for conference distribution */
#define MSG_TYPENET     0x02000000L /* Msg is direct network mail */
#define MSG_NODISP      0x20000000L /* Msg may not be displayed to user */
#define MSG_LOCKED      0x40000000L /* Msg is locked, no editing possible */
#define MSG_DELETED     0x80000000L /* Msg is deleted */

int _bfs_ConvertToUTF8(unsigned long srcEncoding, const char *src, long *srcLen,
																									char *dst, long *dstLen);
int _bfs_ConvertFromUTF8(unsigned long dstEncoding, const char *src, long *srcLen,
																									char *dst, long *dstLen);

void _bfs_SetMIMEType(char *file, char *type);

/*
int bfs_ReadMsgAttributes(char * path,struct StoredMsg *Msg,int bArea);
//int bfs_WriteMsgAttributes(char * path,struct StoredMsg *Msg,char *AreaName,int bArea);
int bfs_WriteMsgAttributes(char *path, struct MemMessage *mm);
int bfs_ReadAreaAttributes(char * path,struct AreaAttr *attr);
int bfs_WriteAreaAttributes(char * path,struct AreaAttr *attr);
int bfs_WriteText(char * path,char *text,int len);
int bfs_WriteSeenBy(char *path,char *sbbuf,int len);

int bfs_WritePath(char *path, char *data,int len);
int bfs_ReadAttrib(char *path, char *data, char *attrName, int buf_len);
 */
#ifdef __cplusplus
}
#endif 
